#include "crypto_verify.h"

#include <emmintrin.h>

int crypto_verify(const unsigned char *x,const unsigned char *y)
{
  __m128i acc, tmp;
  int diff;

#define F(tmp, i)							\
  tmp = _mm_sad_epu8(((const __m128i *)(x))[i],				\
		     ((const __m128i *)(y))[i])
#define G(tmp)					\
  acc = _mm_or_si128(acc, tmp)

  F(acc, 0);

  tmp = _mm_shuffle_epi32(acc, 0x02);
  G(tmp);

  diff = _mm_extract_epi16(acc, 0) & 0xFFFF;

  return (1 & ((diff - 1) >> 16)) - 1;
}
