#include "crypto_verify.h"
#include "crypto_uint32.h"

int crypto_verify(const unsigned char *x,const unsigned char *y)
{
  crypto_uint32 differentbits = 0;
#define F(i) differentbits |= ((const crypto_uint32 *)(x))[i] \
                            ^ ((const crypto_uint32 *)(y))[i]
  F(0);
  F(1);
  F(2);
  F(3);

  differentbits |= (differentbits >> 16);
  differentbits &= 0xFFFF;
  return (1 & ((differentbits - 1) >> 16)) - 1;
}
