#include "crypto_verify.h"

#include <mmintrin.h>
#include <xmmintrin.h>

int crypto_verify(const unsigned char *x,const unsigned char *y)
{
  __m64 acc, tmp;
  int diff;

#define F(tmp, i)							\
  tmp = _mm_sad_pu8(((const __m64 *)(x))[i],				\
		    ((const __m64 *)(y))[i])
#define G(tmp)					\
  acc = _mm_or_si64(acc, tmp)

  F(acc, 0);
  F(tmp, 1); G(tmp);

  diff = _mm_extract_pi16(acc, 0);

  _mm_empty();

  return (1 & ((diff - 1) >> 16)) - 1;
}
