#include "crypto_verify.h"
#include "crypto_uint32.h"

#include <mmintrin.h>

int crypto_verify(const unsigned char *x,const unsigned char *y)
{
  __m64 acc, tmp;
  crypto_uint32 buf[2];
  crypto_uint32 differentbits;

#define F(tmp, i)							\
  tmp = _mm_xor_si64(((const __m64 *)(x))[i],				\
		     ((const __m64 *)(y))[i])
#define G(tmp)					\
  acc = _mm_or_si64(acc, tmp)

  F(acc, 0);
  F(tmp, 1); G(tmp);
  F(tmp, 2); G(tmp);
  F(tmp, 3); G(tmp);

  G(_mm_srli_si64(acc, 16));
  G(_mm_srli_si64(acc, 32));
  *((__m64 *)(buf)) = acc;

  _mm_empty();

  differentbits = buf[0] & 0xFFFF;
  return (1 & ((differentbits - 1) >> 16)) - 1;
}
