#include "crypto_verify.h"
#include "crypto_uint64.h"

int crypto_verify(const unsigned char *x,const unsigned char *y)
{
  crypto_uint64 differentbits = 0;
#define F(i) differentbits |= ((const crypto_uint64 *)(x))[i] \
                            ^ ((const crypto_uint64 *)(y))[i]
  F(0);
  F(1);
  F(2);
  F(3);

  differentbits |= (differentbits >> 32);
  differentbits &= 0xFFFFFFFF;
  return (1 & ((differentbits - 1) >> 32)) - 1;
}
