#include "crypto_verify.h"

#include <mmintrin.h>
#include <xmmintrin.h>

int crypto_verify(const unsigned char *x,const unsigned char *y)
{
  __m64 acc, tmp;
  int differentbits;

#define F(tmp, i)							\
  tmp = _mm_xor_si64(((const __m64 *)(x))[i],				\
		     ((const __m64 *)(y))[i])
#define G(tmp)					\
  acc = _mm_or_si64(acc, tmp)

  F(acc, 0);
  F(tmp, 1); G(tmp);
  F(tmp, 2); G(tmp);
  F(tmp, 3); G(tmp);

  acc = _mm_or_si64(acc,
		    _mm_srli_si64(acc, 16));
  acc = _mm_or_si64(acc,
		    _mm_srli_si64(acc, 32));
  differentbits = _mm_extract_pi16(acc, 0) & 0xFFFF;
  _mm_empty();

  return (1 & ((differentbits - 1) >> 16)) - 1;
}
